﻿Imports System.Xml
Imports System.Text
Imports System.Data.Objects

Public Class Refactor

    Dim SVGstring = "<svg   xmlns:xlink=""http://www.w3.org/1999/xlink"">"
    Private Sub btnRefactor_Click(sender As System.Object, e As System.EventArgs) Handles btnRefactor.Click
        Dim context = New iswaEntities()

        Dim FromId As Integer = 1
        Dim Qty As Integer = 40000

        Dim Tiny = True

        ResetDatabase(context)
        context.SaveChanges()

        If Not context.Connection.State = ConnectionState.Open Then
            context.Connection.Open()
        End If
        Dim transaction = context.Connection.BeginTransaction()

        RefactorParts(context, FromId, Qty, Tiny)
        RefactorBaseFills(context, FromId, Qty, Tiny)
        RefactorSymbols(context, FromId, Qty, Tiny)

        MakeTestPage(context, "test.svg", FromId, Qty, Tiny)

        context.SaveChanges()

        transaction.Commit()
        MessageBox.Show("Finished")
    End Sub
    Private Sub ResetDatabase(context As iswaEntities)
        Dim queryDelete = context.ExecuteStoreCommand("DELETE FROM font_svg1")
        Dim queryDelete1 = context.ExecuteStoreCommand("DELETE FROM font_svg1_symbols")
        Dim queryDelete2 = context.ExecuteStoreCommand("DELETE FROM font_svg1_parts")
        Dim queryDelete3 = context.ExecuteStoreCommand("DELETE FROM font_svg1_codeparts")
        Dim queryDelete4 = context.ExecuteStoreCommand("DELETE FROM font_svg1_basefills")
        Dim queryDelete5 = context.ExecuteStoreCommand("DELETE FROM font_svg1_bfp")
        Dim queryInsert = context.ExecuteStoreCommand("INSERT INTO font_svg1 SELECT *, NULL FROM font_svg1_original")
    End Sub
    Private Function SVGNameTable() As NameTable
        Dim nameTable As NameTable = New NameTable()
        Dim namespaceManager As XmlNamespaceManager = New XmlNamespaceManager(nameTable)
        namespaceManager.AddNamespace("xmlns:svg", "http://www.w3.org/2000/svg")
        namespaceManager.AddNamespace("xmlns:xlink", "http://www.w3.org/1999/xlink")
        Return nameTable
    End Function

    Private Sub RefactorParts(context As iswaEntities, FromId As Integer, Qty As Integer, Tiny As Boolean)
        Dim glyphChildCount As Integer = 0
        Dim defid As Tuple(Of String, Integer)
        Dim sb As New StringBuilder
        ' Create a document fragment. 
        Dim xmlglyph As New Xml.XmlDocument(SVGNameTable())
        Dim DefsDictionary As New Dictionary(Of String, Tuple(Of String, Integer))


        For Each row In GetRowstoRefactor(context, FromId, Qty)
            xmlglyph.InnerXml = SVGstring & FilltoClass(row.glyph) & "</svg>"

            glyphChildCount = 0
            Dim gNode = GetLastGNode(xmlglyph.FirstChild)
            sb.Clear()
            For Each nodechild As Xml.XmlNode In gNode.ChildNodes
                If Not nodechild.Name = "#whitespace" Then
                    glyphChildCount += 1
                    removeids(nodechild)


                    Dim nodechildOuter As String = nodechild.OuterXml

                    If Not DefsDictionary.TryGetValue(nodechildOuter, defid) Then
                        Dim defidtemp As String = "p" & row.code & "_" & glyphChildCount
                        Dim partId = AddtoParts(context, nodechild, defidtemp, row.code, Tiny)
                        defid = Tuple.Create(defidtemp, partId)
                        DefsDictionary.Add(nodechildOuter, defid)
                    End If
                    AddtoCodeParts(context, row.code, defid.Item2)
                    sb.Append(CreateUseTag(defid.Item1))
                End If
            Next

            gNode.InnerXml = sb.ToString()
            row.glyph = removeSVGTag(xmlglyph.InnerXml)
        Next
        context.SaveChanges()
    End Sub

    Private Sub RefactorBaseFills(context As iswaEntities, FromId As Integer, Qty As Integer, Tiny As Boolean)
        Dim defid As Tuple(Of String, Integer)

        Dim xmlglyph As New Xml.XmlDocument(SVGNameTable())
        Dim BaseFillsDictionary As New Dictionary(Of String, Tuple(Of String, Integer))


        For Each row In GetRowstoRefactor(context, FromId, Qty)
            xmlglyph.InnerXml = SVGstring & FilltoClass(row.glyph) & "</svg>"

            Dim gNode = GetLastGNode(xmlglyph.FirstChild)
            removeids(gNode)


            Dim nodechildOuter As String = "<g>" & gNode.InnerXml & "</g>"
            nodechildOuter = RemoveXlink(nodechildOuter)


            If Not BaseFillsDictionary.TryGetValue(nodechildOuter, defid) Then
                Dim Tempdefid As String = "b" & row.code

                Dim tempbfid = AddtoBaseFills(context, gNode, Tempdefid, row.code, Tiny)
                defid = Tuple.Create(Tempdefid, tempbfid.Value)
                AddtoBFParts(context, row.code)

                BaseFillsDictionary.Add(nodechildOuter, defid)
            End If
            row.bfid = defid.Item2

            Dim firstgNode = GetFirstGNode(xmlglyph.FirstChild)
            removeattribute(firstgNode, "id")

            firstgNode.InnerXml = CreateUseTag(defid.Item1)
            row.glyph = removeSVGTag(xmlglyph.InnerXml)
        Next
        context.SaveChanges()
    End Sub
    Private Sub RefactorSymbols(context As iswaEntities, FromId As Integer, Qty As Integer, Tiny As Boolean)
        Dim defid As String
        Dim xmlglyph As New Xml.XmlDocument(SVGNameTable())

        For Each row In GetRowstoRefactor(context, FromId, Qty)
            xmlglyph.InnerXml = SVGstring & FilltoClass(row.glyph) & "</svg>"

            Dim gNode = xmlglyph.FirstChild

            removeids(gNode)
            defid = "c" & row.code

            Addglyphid(gNode.FirstChild, defid)
            Dim xml = RemoveXlink(gNode.InnerXml)
            AddtoSymbols(context, xml, defid, row.code, row.bfid, Tiny)
            row.glyph = CreateUseTag(defid)
        Next
        context.SaveChanges()
    End Sub
    Private Function GetRowstoRefactor(context As iswaEntities, FromID As Integer, Qty As Integer) As IQueryable
        Dim font_svg1 = context.font_svg1
        Return font_svg1.Where(Function(x) x.code >= FromID).Take(Qty)
    End Function
    Private Function FilltoClass(Str As String) As String
        Return Str.Replace("fill=""#000000""", "class=""nb""").Replace("fill=""#ffffff""", "class=""nw""")
    End Function
    Private Function RemoveXlink(Str As String) As String
        Return Str.Replace(" xmlns:xlink=""http://www.w3.org/1999/xlink""", "")
    End Function
    Private Function removeids(node As Xml.XmlNode) As String
        removeattribute(node, "id")
        Return node.InnerXml
    End Function
    Private Sub removeattribute(node As Xml.XmlNode, attrb As String)
        If node.Attributes IsNot Nothing Then
            node.Attributes.RemoveNamedItem(attrb)
        End If
    End Sub

    Private Function AddtoParts(context As iswaEntities, node As XmlNode, elementid As String, code As Integer, Tiny As Boolean) As Integer
        Dim Defs = context.font_svg1_parts
        Static ID As Integer = 0
        ID += 1
        Dim NewDef = Defs.CreateObject()
        removeattribute(node, "xmlns")
        NewDef.partid = ID
        Addglyphid(node, elementid)
        If Tiny Then
            NewDef.xml = Shorten(node.OuterXml)
        Else
            NewDef.xml = node.OuterXml
        End If

        NewDef.code = code
        Defs.AddObject(NewDef)
        context.SaveChanges()
        Return ID
    End Function

    Private Function AddtoBaseFills(context As iswaEntities, node As XmlNode, elementid As String, code As Integer, Tiny As Boolean) As Integer?
        Dim Defs = context.font_svg1_basefills
        Dim BFParts = context.font_svg1_codeparts
        Static ID As Integer = 0
        ID += 1

        Dim NewDef = Defs.CreateObject()
        removeattribute(node.ParentNode, "xmlns")

        NewDef.bfid = code
        Addglyphid(node, elementid)
        If Tiny Then
            NewDef.xml = Shorten(RemoveXlink(node.OuterXml))
        Else
            NewDef.xml = RemoveXlink(node.OuterXml)
        End If

        Defs.AddObject(NewDef)


        context.SaveChanges()
        Return NewDef.bfid
    End Function
    Private Sub AddtoCodeParts(context As iswaEntities, code As Integer, partid As Integer)
        Dim BFParts = context.font_svg1_codeparts

        Static codepartsid As Integer = 0
        codepartsid += 1

        Dim NewBFPart = BFParts.CreateObject
        NewBFPart.codepartsid = codepartsid
        NewBFPart.code = code
        NewBFPart.partid = partid

        BFParts.AddObject(NewBFPart)

        context.SaveChanges()
    End Sub
    Private Sub AddtoBFParts(context As iswaEntities, bfid As Integer)
        Dim BFParts = context.font_svg1_bfp

        Dim Parts = From m In context.font_svg1_codeparts Where m.code = bfid Distinct

        Static bgpartsid As Integer = 0

        For Each row In Parts
            Dim NewBFPart = BFParts.CreateObject
            bgpartsid += 1
            NewBFPart.bfpid = bgpartsid
            NewBFPart.bfid = row.code
            NewBFPart.partid = row.partid

            BFParts.AddObject(NewBFPart)
        Next
        context.SaveChanges()
    End Sub
    Private Function AddtoSymbols(context As iswaEntities, symbol As String, elementid As String, code As Integer, bfid As Integer, Tiny As Boolean) As Integer?
        Dim Defs = context.font_svg1_symbols
        Dim NewDef = Defs.CreateObject()

        NewDef.code = code
        If Tiny Then
            NewDef.xml = Shorten(symbol)
        Else
            NewDef.xml = symbol
        End If
        NewDef.bfid = bfid
        Defs.AddObject(NewDef)
        context.SaveChanges()
        Return NewDef.code
    End Function


    Private Sub Addglyphid(node As XmlNode, elementid As String)
        Dim doc As New XmlDocument(SVGNameTable())
        Dim attr As XmlNode = doc.CreateNode(XmlNodeType.Attribute, "id", Nothing)
        attr.Value = elementid

        node.Attributes.SetNamedItem(attr)

    End Sub

    Private Function CreateUseTag(glyphid As String) As String
        Return "<use xlink:href=""#" & glyphid & """ />"
    End Function

    Private Function GetLastGNode(xmlglyph As XmlElement) As XmlElement
        If xmlglyph.HasChildNodes() AndAlso ContainsGNode(xmlglyph.ChildNodes) Then
            Return GetLastGNode(xmlglyph.FirstChild)
        Else
            Return xmlglyph
        End If
    End Function
    Private Function GetFirstGNode(xmlglyph As XmlElement) As XmlElement
        If xmlglyph.HasChildNodes() AndAlso xmlglyph.FirstChild.Name = "g" Then
            Return xmlglyph.FirstChild
        Else
            Return GetFirstGNode(xmlglyph.FirstChild)
        End If
    End Function

    Private Function ContainsGNode(xmlNodeList As XmlNodeList) As Boolean
        For Each node As XmlNode In xmlNodeList
            If node.Name = "g" OrElse ContainsGNode(node.ChildNodes) Then
                Return True
            End If
        Next
        Return False
    End Function

    Private Function removeSVGTag(str As String) As String
        Return str.Replace("<svg xmlns:xlink=""http://www.w3.org/1999/xlink"">", "").Replace("</svg>", "")
    End Function


    Private Sub MakeTestPage(context As iswaEntities, Filename As String, FromId As Integer, Qty As Integer, Tiny As Boolean)
        Dim Defs As New StringBuilder
        Dim MainDocument As New StringBuilder
        Dim Svg1 As New StringBuilder
        Svg1.Append("<?xml version=""1.0"" encoding=""UTF-8"" standalone=""no""?> ")


        Svg1.Append("<svg ")
        Svg1.Append("xmlns:svg = ""http://www.w3.org/2000/svg"" ")
        Svg1.Append("xmlns = ""http://www.w3.org/2000/svg"" ")
        Svg1.Append("xmlns:xlink = ""http://www.w3.org/1999/xlink"" ")

        Svg1.Append("width = ""100"" ")
        Svg1.Append("height = """)
        Svg1.Append(50 * Qty)
        Svg1.Append(""" ")
        Svg1.Append("id = ""svg2"" ")
        Svg1.Append("> ")
        Svg1.Append("<defs id=""defs4""> ")
        Svg1.Append("<style type=""text/css""> <![CDATA[&pnd;myshape { fill: green; stroke: blue; stroke-width: 3 } .nw {fill: white; } .nb {fill: black ; } &pnd;thisshape .nw { fill: green; stroke: purple; }  &pnd;thisshape .nb { fill: pink; stroke: blue; } ]]> </style>".Replace("&pnd;", "#"))
        Dim Svg2 As New StringBuilder
        Svg2.Append("</defs> ")

        Dim Svg3 As New StringBuilder
        Svg3.Append("</svg> ")
        Dim LastId = GetLastId(context, FromId, Qty)
        GetDefs(context, Defs, FromId, LastId, Tiny)
        GetMainDocument(context, MainDocument, FromId, LastId)

        Dim TextWriter As New IO.StringWriter
        Using outfile As New IO.StreamWriter(Filename)
            outfile.Write(Svg1.ToString())
            outfile.Write(Defs.ToString())
            outfile.Write(Svg2.ToString())
            outfile.Write(MainDocument.ToString())
            outfile.Write(Svg3.ToString())
        End Using
    End Sub
  
    Private Sub GetDefs(context As iswaEntities, Defs As StringBuilder, FromId As Integer, LastId As Integer, Tiny As Boolean)
        Dim parts = From symbolstable In context.font_svg1_symbols Where symbolstable.code >= FromId And symbolstable.code <= LastId
        Join basefillstable In context.font_svg1_basefills On symbolstable.bfid Equals basefillstable.bfid
        Join bfparts In context.font_svg1_bfp On basefillstable.bfid Equals bfparts.bfid
        Join partstable In context.font_svg1_parts On bfparts.partid Equals partstable.partid Distinct Select partstable.xml

        Dim basefills = From symbolstable In context.font_svg1_symbols Where symbolstable.code >= FromId And symbolstable.code <= LastId
          Join basefillstable In context.font_svg1_basefills On symbolstable.bfid Equals basefillstable.bfid Distinct Select basefillstable.xml

        Dim symbols = From symbolstable In context.font_svg1_symbols Where symbolstable.code >= FromId And symbolstable.code <= LastId
          Distinct Select symbolstable.xml

        For Each item In parts
            Defs.Append(item)
        Next
        For Each item In basefills
            Defs.Append(item)
        Next
        For Each item In symbols
            Defs.Append(item)
        Next
        Console.WriteLine(CType(parts, ObjectQuery).ToTraceString)
        Console.WriteLine(CType(basefills, ObjectQuery).ToTraceString)
        Console.WriteLine(CType(symbols, ObjectQuery).ToTraceString)
        If Tiny Then
            Lengthen(Defs)
        End If
    End Sub
    Private Sub GetMainDocument(context As iswaEntities, MainDocument As StringBuilder, FromId As Integer, LastId As Integer)
        Dim Deftable = context.font_svg1_parts
        Dim a = From font1 In context.font_svg1_original
                Where font1.code >= FromId AndAlso font1.code <= LastId
                Join second In context.font_svg1 On font1.code Equals second.code Select (New With {.fontglyph = font1.glyph, .code = font1.code})
        Dim I As Integer = 0

        For Each item In a
            I += 1
            MainDocument.Append("<g transform=""translate(")
            MainDocument.Append(0)
            MainDocument.Append(" ")
            MainDocument.Append(I * 50)
            MainDocument.Append(")"">")
            MainDocument.Append(item.fontglyph)
            MainDocument.Append("</g>")

            MainDocument.Append("<use xlink:href=""&pnd;".Replace("&pnd;", "#"))
            MainDocument.Append("c")
            MainDocument.Append(item.code)
            MainDocument.Append(""" transform=""translate(")
            MainDocument.Append(50)
            MainDocument.Append(" ")
            MainDocument.Append(I * 50)
            MainDocument.Append(")""/>")

        Next
    End Sub

    Private Function GetLastId(context As iswaEntities, FromId As Integer, Qty As Integer) As Integer
        Dim Font1 = context.font_svg1
        Return Font1.Where(Function(x) x.code >= FromId).Take(Qty).ToList().Last().code
    End Function

    Private Sub BtnExport_Click(sender As System.Object, e As System.EventArgs) Handles BtnExport.Click
        Dim context = New iswaEntities()

        context.SaveChanges()
        If Not context.Connection.State = ConnectionState.Open Then
            context.Connection.Open()
        End If
        Dim transaction = context.Connection.BeginTransaction()

        ExportParts(context)
        ExportBaseFills(context)
        ExportSymbols(context)

        transaction.Commit()
        MessageBox.Show("Finished")
    End Sub

    Private Sub ExportParts(context As iswaEntities)
        Dim Parts = context.font_svg1_parts
        Dim StreamWriter As New IO.StreamWriter("parts.csv")
        For Each row In Parts
            StreamWriter.WriteLine(row.xml)
        Next
        StreamWriter.Flush()
        StreamWriter.Close()
    End Sub

    Private Sub ExportBaseFills(context As iswaEntities)
        Dim BaseFills = context.font_svg1_basefills
        Dim StreamWriter As New IO.StreamWriter("basefills.csv")
        For Each row In BaseFills
            StreamWriter.WriteLine(row.xml)
        Next
        StreamWriter.Flush()
        StreamWriter.Close()

    End Sub

    Private Sub ExportSymbols(context As iswaEntities)
        Dim Symbols = context.font_svg1_symbols
        Dim StreamWriter As New IO.StreamWriter("symbols.csv")
        For Each row In Symbols
            StreamWriter.WriteLine(row.xml)
        Next
        StreamWriter.Flush()
        StreamWriter.Close()
    End Sub
    Private Function ReplaceList() As List(Of Tuple(Of String, String))
        Dim Replace As New List(Of Tuple(Of String, String))
        Replace.Add(Tuple.Create("<g transform=""translate(", "a;"))
        Replace.Add(Tuple.Create("<path transform=""matrix(", "b;"))
        Replace.Add(Tuple.Create("<path transform=""", "c;"))
        Replace.Add(Tuple.Create("<g transform=""scale", "d;"))
        Replace.Add(Tuple.Create("<g transform=""", "e;"))
        Replace.Add(Tuple.Create("><use xlink:href=""#", "f;"))
        Replace.Add(Tuple.Create("<rect transform=""", "g;"))
        Replace.Add(Tuple.Create("scale(-1,1)"" id=""c", "h;"))
        Replace.Add(Tuple.Create("<path d=""M", "i;"))
        Replace.Add(Tuple.Create("<path d=""m", "j;"))
        Replace.Add(Tuple.Create(" class=""n", "k;"))
        Replace.Add(Tuple.Create("translate", "l;"))
        Replace.Add(Tuple.Create("<rect x=""", "m;"))
        Replace.Add(Tuple.Create("0) rotate(90)", "n;"))
        Replace.Add(Tuple.Create("30) rotate(180)", "o;"))
        Replace.Add(Tuple.Create("<g id=""b", "p;"))
        Replace.Add(Tuple.Create(""" /></g>", "q;"))
        Replace.Add(Tuple.Create(""" width=""", "r;"))
        Replace.Add(Tuple.Create(""" height=""", "s;"))
        Replace.Add(Tuple.Create("rotate", "t;"))
        Replace.Add(Tuple.Create("scale(", "u;"))
        Replace.Add(Tuple.Create("matrix(", "v;"))
        Return Replace
    End Function

    Private Function Shorten(ToShorten As String) As String
        Static Dim RL = ReplaceList()
        Static Dim SB As New StringBuilder
        SB.Clear()
        SB.Append(ToShorten)

        For Each ToReplace In RL
            SB.Replace(ToReplace.item1, ToReplace.item2)
        Next
        Return SB.ToString
    End Function

    Private Function Lengthen(ToLengthen As String) As String
        Static Dim RL = ReplaceList()
        Static Dim SB As New StringBuilder
        SB.Clear()
        SB.Append(ToLengthen)

        For Each ToReplace In RL
            SB.Replace(ToReplace.item2, ToReplace.item1)
        Next

        Return SB.ToString
    End Function
    Private Sub Lengthen(SB As StringBuilder)
        Static Dim RL = ReplaceList()

        For Each ToReplace In RL
            SB.Replace(ToReplace.item2, ToReplace.item1)
        Next
    End Sub

    Private Sub BtnGetSymbols_Click(sender As Object, e As EventArgs) Handles BtnGetSymbols.Click
        Dim context = New iswaEntities()
        If Not context.Connection.State = ConnectionState.Open Then
            context.Connection.Open()
        End If
        Dim transaction = context.Connection.BeginTransaction()

        If IsNumeric(TBFrom.Text) AndAlso IsNumeric(TBTo.Text) Then
            Dim FromCode = CInt(TBFrom.Text)
            Dim ToCode = CInt(TBTo.Text)

            GetSymbols(context, FromCode, ToCode)
            transaction.Commit()
            MessageBox.Show("Finished")
        Else
            MessageBox.Show("From Code and To Code must be Integers")
        End If


    End Sub

    Private Sub GetSymbols(context As iswaEntities, FromCode As Integer, ToCode As Integer)
        Dim Defs As New StringBuilder
        Dim MainDocument As New StringBuilder
        Dim Svg1 As New StringBuilder
        Svg1.Append("<?xml version=""1.0"" encoding=""UTF-8"" standalone=""no""?> ")


        Svg1.Append("<svg ")
        Svg1.Append("xmlns:svg = ""http://www.w3.org/2000/svg"" ")
        Svg1.Append("xmlns = ""http://www.w3.org/2000/svg"" ")
        Svg1.Append("xmlns:xlink = ""http://www.w3.org/1999/xlink"" ")

        Svg1.Append("width = ""200"" ")
        Svg1.Append("height = """)
        Svg1.Append(50 * (ToCode - FromCode + 1))
        Svg1.Append(""" ")
        Svg1.Append("id = ""svg2"" ")
        Svg1.Append("> ")
        Svg1.Append("<defs id=""defs4""> ")
        Svg1.Append("<style type=""text/css""> <![CDATA[&pnd;myshape { fill: green; stroke: blue; stroke-width: 3 } .nw {fill: white; } .nb {fill: black ; } &pnd;thisshape .nw { fill: green; stroke: purple; }  &pnd;thisshape .nb { fill: pink; stroke: blue; } ]]> </style>".Replace("&pnd;", "#"))
        Dim Svg2 As New StringBuilder
        Svg2.Append("</defs> ")

        Dim Svg3 As New StringBuilder
        Svg3.Append("</svg> ")

        GetDefs(context, Defs, FromCode, ToCode, True)
        GetSymbolsDocument(context, MainDocument, FromCode, ToCode)

        Dim TextWriter As New IO.StringWriter
        Using outfile As New IO.StreamWriter("Symbols " & FromCode & " - " & ToCode & ".svg")
            outfile.Write(Svg1.ToString())
            outfile.Write(Defs.ToString())
            outfile.Write(Svg2.ToString())
            outfile.Write(MainDocument.ToString())
            outfile.Write(Svg3.ToString())
        End Using
    End Sub
    Private Sub GetSymbolsDocument(context As iswaEntities, MainDocument As StringBuilder, FromCode As Integer, ToCode As Integer)
        Dim Deftable = context.font_svg1_parts
        Dim I As Integer = 0
        For I = FromCode To ToCode

            MainDocument.Append("<use xlink:href=""&pnd;".Replace("&pnd;", "#"))
            MainDocument.Append("c")
            MainDocument.Append(I)
            MainDocument.Append(""" transform=""translate(")
            MainDocument.Append(50)
            MainDocument.Append(" ")
            MainDocument.Append((I - FromCode) * 50)
            MainDocument.Append(")""/>")

        Next
    End Sub
    Private Sub BtnGetSymbolsArray_Click(sender As Object, e As EventArgs) Handles BtnGetSymbolsArray.Click
        Dim context = New iswaEntities()
        If Not context.Connection.State = ConnectionState.Open Then
            context.Connection.Open()
        End If
        Dim transaction = context.Connection.BeginTransaction()

        Dim StrArray = TBCodes.Text.Split(",")
        Dim NumArray(StrArray.Length - 1) As Integer
        Dim I = 0
        For Each item In StrArray
            If IsNumeric(item) Then
                NumArray(I) = CInt(item)
                I += 1
            End If
        Next




        GetSymbolsArray(context, NumArray)

        MessageBox.Show("Finished")


        transaction.Commit()
    End Sub
    Private Sub GetSymbolsArray(context As iswaEntities, Codes As Integer())
        Dim Defs As New StringBuilder
        Dim MainDocument As New StringBuilder
        Dim Svg1 As New StringBuilder
        Svg1.Append("<?xml version=""1.0"" encoding=""UTF-8"" standalone=""no""?> ")


        Svg1.Append("<svg ")
        Svg1.Append("xmlns:svg = ""http://www.w3.org/2000/svg"" ")
        Svg1.Append("xmlns = ""http://www.w3.org/2000/svg"" ")
        Svg1.Append("xmlns:xlink = ""http://www.w3.org/1999/xlink"" ")

        Svg1.Append("width = ""200"" ")
        Svg1.Append("height = """)
        Svg1.Append(50 * (Codes.Length + 1))
        Svg1.Append(""" ")
        Svg1.Append("id = ""svg2"" ")
        Svg1.Append("> ")
        Svg1.Append("<defs id=""defs4""> ")
        Svg1.Append("<style type=""text/css""> <![CDATA[&pnd;myshape { fill: green; stroke: blue; stroke-width: 3 } .nw {fill: white; } .nb {fill: black ; } &pnd;thisshape .nw { fill: green; stroke: purple; }  &pnd;thisshape .nb { fill: pink; stroke: blue; } ]]> </style>".Replace("&pnd;", "#"))
        Dim Svg2 As New StringBuilder
        Svg2.Append("</defs> ")

        Dim Svg3 As New StringBuilder
        Svg3.Append("</svg> ")

        GetDefs(context, Defs, Codes, True)
        GetSymbolsDocument(context, MainDocument, Codes)

        Dim TextWriter As New IO.StringWriter
        Using outfile As New IO.StreamWriter("Symbols " & String.Join(",", Codes) & ".svg")
            outfile.Write(Svg1.ToString())
            outfile.Write(Defs.ToString())
            outfile.Write(Svg2.ToString())
            outfile.Write(MainDocument.ToString())
            outfile.Write(Svg3.ToString())
        End Using
    End Sub

    Private Sub GetDefs(context As iswaEntities, Defs As StringBuilder, Codes As Integer(), Tiny As Boolean)
        Dim parts = From symbolstable In context.font_svg1_symbols Where Codes.Contains(symbolstable.code)
        Join basefillstable In context.font_svg1_basefills On symbolstable.bfid Equals basefillstable.bfid
        Join bfparts In context.font_svg1_bfp On basefillstable.bfid Equals bfparts.bfid
        Join partstable In context.font_svg1_parts On bfparts.partid Equals partstable.partid Distinct Select partstable.xml

        Dim basefills = From symbolstable In context.font_svg1_symbols Where Codes.Contains(symbolstable.code)
          Join basefillstable In context.font_svg1_basefills On symbolstable.bfid Equals basefillstable.bfid Distinct Select basefillstable.xml

        Dim symbols = From symbolstable In context.font_svg1_symbols Where Codes.Contains(symbolstable.code)
           Distinct Select symbolstable.xml

        For Each item In parts
            Defs.Append(item)
        Next
        For Each item In basefills
            Defs.Append(item)
        Next
        For Each item In symbols
            Defs.Append(item)
        Next

        Console.WriteLine(CType(parts, ObjectQuery).ToTraceString)
        Console.WriteLine(CType(basefills, ObjectQuery).ToTraceString)
        Console.WriteLine(CType(symbols, ObjectQuery).ToTraceString)

        If Tiny Then
            Lengthen(Defs)
        End If
    End Sub

    Private Sub GetSymbolsDocument(context As iswaEntities, MainDocument As StringBuilder, Codes As Integer())
        Dim Deftable = context.font_svg1_parts
        Dim I As Integer = 0


        For Each Code In Codes
            I += 1
            MainDocument.Append("<use xlink:href=""&pnd;".Replace("&pnd;", "#"))
            MainDocument.Append("c")
            MainDocument.Append(Code)
            MainDocument.Append(""" transform=""translate(")
            MainDocument.Append(50)
            MainDocument.Append(" ")
            MainDocument.Append((I - 1) * 50)
            MainDocument.Append(")""/>")

        Next
    End Sub

  
    Private Sub BtnParts_Click(sender As System.Object, e As System.EventArgs) Handles BtnParts.Click
        Dim context = New iswaEntities()
        If Not context.Connection.State = ConnectionState.Open Then
            context.Connection.Open()
        End If
        Dim transaction = context.Connection.BeginTransaction()

        Dim parts = From partstable In context.font_svg1_parts Distinct Select partstable.xml


        Dim Defs As New StringBuilder
        Dim MainDocument As New StringBuilder
        Dim Svg1 As New StringBuilder
        Svg1.Append("<?xml version=""1.0"" encoding=""UTF-8"" standalone=""no""?> ")


        Svg1.Append("<svg ")
        Svg1.Append("xmlns:svg = ""http://www.w3.org/2000/svg"" ")
        Svg1.Append("xmlns = ""http://www.w3.org/2000/svg"" ")
        Svg1.Append("xmlns:xlink = ""http://www.w3.org/1999/xlink"" ")

        Svg1.Append("width = ""100"" ")
        Svg1.Append("height = """)
        Svg1.Append(50 * parts.Count())
        Svg1.Append(""" ")
        Svg1.Append("id = ""svg2"" ")
        Svg1.Append("> ")
        Svg1.Append("<defs id=""defs4""> ")
        Svg1.Append("<style type=""text/css""> <![CDATA[&pnd;myshape { fill: green; stroke: blue; stroke-width: 3 } .nw {fill: white; } .nb {fill: black ; } &pnd;thisshape .nw { fill: green; stroke: purple; }  &pnd;thisshape .nb { fill: pink; stroke: blue; } ]]> </style>".Replace("&pnd;", "#"))
        Dim Svg2 As New StringBuilder
        Svg2.Append("</defs> ")

        Dim Svg3 As New StringBuilder
        Svg3.Append("</svg> ")
       
        Dim Deftable = context.font_svg1_parts
         Dim I As Integer = 0

        For Each item In parts
            I += 1
            MainDocument.Append("<g transform=""translate(")
            MainDocument.Append(50)
            MainDocument.Append(" ")
            MainDocument.Append(I * 50)
            MainDocument.Append(")"">")
            MainDocument.Append(item)
            MainDocument.Append("</g>")

          

        Next

        Dim TextWriter As New IO.StringWriter
        Using outfile As New IO.StreamWriter("Parts.svg")
            outfile.Write(Svg1.ToString())
            outfile.Write(Defs.ToString())
            outfile.Write(Svg2.ToString())
            outfile.Write(MainDocument.ToString())
            outfile.Write(Svg3.ToString())
        End Using


        MessageBox.Show("Finished")


        transaction.Commit()
    End Sub
End Class
